=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class CarrierMasterAccountsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get Carrier Registration status
    # Gets the registration status for the given account for the given carrier
    # @param carrier 
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [CarrierRegisterStatusResponse]
    def carrier_register_status(carrier, merchant_id, opts = {})
      data, _status_code, _headers = carrier_register_status_with_http_info(carrier, merchant_id, opts)
      data
    end

    # Get Carrier Registration status
    # Gets the registration status for the given account for the given carrier
    # @param carrier 
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(CarrierRegisterStatusResponse, Integer, Hash)>] CarrierRegisterStatusResponse data, response status code and response headers
    def carrier_register_status_with_http_info(carrier, merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierMasterAccountsApi.carrier_register_status ...'
      end
      # verify the required parameter 'carrier' is set
      if @api_client.config.client_side_validation && carrier.nil?
        fail ArgumentError, "Missing the required parameter 'carrier' when calling CarrierMasterAccountsApi.carrier_register_status"
      end
      # verify enum value
      if @api_client.config.client_side_validation && !['ups', ' usps', ' canada_post'].include?(carrier)
        fail ArgumentError, "invalid value for 'carrier', must be one of ups,  usps,  canada_post"
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CarrierMasterAccountsApi.carrier_register_status"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/reg-status/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'carrier'] = carrier

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'CarrierRegisterStatusResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierMasterAccountsApi#carrier_register_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add a Shippo master carrier account
    # Add a Shippo master carrier account to the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [CreateCanadaPostMasterAccountRequest] :body Examples.
    # @return [PlatformCarrierRegisterResponse]
    def platform_carrier_registration(opts = {})
      data, _status_code, _headers = platform_carrier_registration_with_http_info(opts)
      data
    end

    # Add a Shippo master carrier account
    # Add a Shippo master carrier account to the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [CreateCanadaPostMasterAccountRequest] :body Examples.
    # @return [Array<(PlatformCarrierRegisterResponse, Integer, Hash)>] PlatformCarrierRegisterResponse data, response status code and response headers
    def platform_carrier_registration_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierMasterAccountsApi.platform_carrier_registration ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/register/new/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'PlatformCarrierRegisterResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierMasterAccountsApi#platform_carrier_registration\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
